#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <math.h>

typedef long long ll;

#define en '\n'

using namespace std;

ll gcd(ll a, ll b) {
	while (a > 1 && b > 1) {
		if (a > b) a %= b;
		else b %= a;
	}
	if (a == 0) return b;
	if (b == 0) return a;
	return 1;
}

bool check(ll x, ll y) {
	ll t = gcd(x, y);
	if (t == 1) return true;
	for (int i = 2; i <= sqrt(t); i++) {
		if (t % i == 0) return false;
	}
	return true;
}

int main() {
	ll x, l, r;
	cin >> x >> l >> r;

	vector<int> ans;
	for (ll i = l; i <= r; i++) {
		if (check(x, i)) {
			ans.push_back(i);
		}
	}

	cout << ans.size() << en;
	for (ll y : ans) cout << y << " ";
	cout << en;
}