from math import ceil, sqrt


def is_sqr(a):
    try:
        return int(sqrt(a)) == sqrt(a)
    except ValueError:
        return False


def factors(a):
    result = []
    for i in range(1, ceil(sqrt(a)) + 1):
        if not a % i:
            result.append(i)
            result.append(a // i)
    return set(result) - {1}


def split_in_2_squares(a):
    for i in range(1, 1000):
        j = a - i*i
        if is_sqr(j):
            return i*i, j
    else:
        return None


if __name__ == '__main__':
    n, k = map(int, input().split())
    if k == 2:
        res = split_in_2_squares(n)
        print(f"YES\n{res[0]} {res[1]}" if res else "NO")
    else:
        print("NO")
