#include <iostream>
#include <vector>

std::vector<int> Sieve;

void BuildSieve( int maxv )
{
  for (int i = 0; i < maxv + 1; i++)
    Sieve.push_back(i);

  for (int i = 2; i < maxv; i++)
  {
    if (Sieve[i] != -1)
      for (int j = i * 2; j < maxv + 1; j += i)
        Sieve[j] = -1;
  }

  std::vector<int> A;
  for (int i = 2; i < maxv + 1; i++)
    if (Sieve[i] != -1)
      A.push_back(Sieve[i]);
  Sieve = A;
}

std::vector<int> getd( int x )
{
  std::vector<int> A;
  for(int i = 0; i < x + 1; i++)
    A.push_back(0);

  int k = 0;
  while (x > 1)
  {
    if (x % Sieve[k] == 0)
    {
      A[Sieve[k]]++;
      x = (int)x / Sieve[k];
    }
    else
      k++;
  }

  return A;
}

int minv( int a, int b )
{
  return a < b ? a : b;
}

bool is_same( std::vector<int> A, std::vector<int> B )
{
  int cnt = 0, sa = A.size(), sb = B.size();
  int size = sa < sb ? sa : sb;

  for (int i = 0; i < size; i++)
    cnt += minv(A[i], B[i]);

  return cnt < 2;
}

int main()
{
  int x, l, r;

  std::cin >> x;
  std::cin >> l;
  std::cin >> r;

  BuildSieve(r > x ? r : x);

  std::vector<int> A = getd(x);

  std::vector<int> Res;

  for (int y = l; y < r + 1; y++)
  {
    std::vector<int> B = getd(y);
    if (is_same(A, B))
      Res.push_back(y);    
  }

  int size = Res.size();
  std::cout << size << '\n';
  for (int i = 0; i < size - 1; i++)
    std::cout << Res[i] << ' ';
  if (size > 0)
    std::cout << Res[size - 1];
}
