#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <math.h>
#include <bitset>
#include <string>

#define x first
#define y second
#define all(x) (x).begin(), (x).end()

#define ll long long
#define ld long double
#define endl '\n'

#define int ll

using namespace std;
const int inf = 1e18;

vector<int> factorize(int x, int k) {
    vector<vector<int>> dp(k + 1, vector<int>(x + 1, inf));
    dp[0][0] = 0;

    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < x; ++j) {
            if (dp[i][j] == inf)
                continue;

            for (int step = dp[i][j] + 1; j + step * step <= x; ++step) {
                dp[i + 1][j + step * step] = min(dp[i + 1][j + step * step], step);
            }
        }
    }

    if (dp[k][x] == inf)
        return {};
    vector<int> res;
    int cur = x;
    for (int i = k; i > 0; --i) {
        res.push_back(dp[i][cur]);
        int step = dp[i][cur] * dp[i][cur];
        cur -= step;
    }
    return res;
}

void solve() {
    int n, k;
    cin >> n >> k;


    vector<int> factor = factorize(n * (k - 1), k);

    if (factor.empty()) {
        cout << "NO" << endl;
    }
    else {
        cout << "YES" << endl;
        for (int i : factor)
            cout << n - i * i << " ";
        cout << endl;
    }
}

signed main()
{
    solve();

    return 0;
}