#include <vector>
#include <iostream>
#include <cmath>
#include <set>

typedef unsigned long long ull;

using namespace std;

void f( ull x, set<ull> &divs )
{
  ull cnt = 1;
  ull pow_2;

  divs.insert(x);

  while (pow_2 = pow(2, cnt), x % pow_2 == 0)
    divs.insert(pow_2), divs.insert(x / pow_2), cnt++;

  ull end = sqrt(x);
  cnt = 1;
  for (ull i = 3; i < end + 1; i += 2)
    while (pow_2 = pow(i, cnt), x % pow_2 == 0)
      divs.insert(pow_2), divs.insert(x / pow_2), cnt++;
}
void sol1()
{
  ull x, l, r;
  set<ull> x_divs;
  vector<ull> com_divs, ans;

  cin >> x >> l >> r;

  com_divs.resize(r);

  f(x, x_divs);             

  for (auto &div : x_divs)
  {
    ull start_pow = floor(log(l) / log(div));
    if (start_pow == 0)
      start_pow = 1;
    ull start = pow(div, start_pow);
    ull cnt = 0;

    while (start + cnt <= r)
    {
      com_divs[start + cnt - 1]++;     
      cnt += div;
    }
  }

  for (ull i = l; i <= r; i++)
    if (com_divs[i - 1] <= 1)
      ans.push_back(i);

  cout << ans.size() << '\n';
  for (auto &a : ans)
    cout << a << ' ';
}

class elem
{
public:
  ull num_of_sums = 0;
  ull sum = 0;
  ull value = 0;
};

void sol2()
{
  ull n, k;
  vector<elem> arr;

  cin >> n >> k;

  for (int i = 0; i < n; i++)
  {
    elem tmp;

    cin >> tmp.value;

    arr.push_back(tmp);
  }

  arr.emplace_back();

  for (int i = 1; i <= n; i++)
  {
    arr[i].sum = arr[i - 1].sum + arr[i - 1].value;
    arr[i].num_of_sums = arr[i - 1].num_of_sums;

    for (int j = 0; j <= i; j++)
      if ((arr[i].value + arr[i].sum - arr[j].sum) % k == 0)
        arr[i].num_of_sums++;
  }

  cout << arr[n - 1].num_of_sums;
}

int main()
{
  sol2();

  return 0;
}