from math import sqrt
from random import randint


def is_prime(n):
    i = 2
    while i <= sqrt(n):
        if n % i == 0:
            return False
        i += 1
    return True

def to_prime_numbers(x):
    nums = []
    i = 2
    while x > 1:
        if x % i != 0 or not is_prime(i):
            i += 1
            continue
        nums.append(i)
        x = x // i
    return nums


def solve(x, l, r):
    if x == 1 or is_prime(x):
        return list(range(l, r + 1))

    unique = to_prime_numbers(x)
    margins = set()

    for i in range(len(unique)):
        for j in range(i):
            margins.add(unique[i] * unique[j])

    margins = sorted(margins)

    firsts = [-1] * len(margins)

    for i in range(l, r + 1):
        for j, m in enumerate(margins):
            if firsts[j] == -1 and i % m == 0:
                firsts[j] = i
        if min(firsts) > -1:
            break

    #print(firsts)

    p = 0

    while p < len(firsts):
        if firsts[p] == -1:
            del firsts[p]
            del margins[p]
        else: p += 1

    i = 0
    forbidden = set()

    while True:
        f = 0
        for j, m in enumerate(margins):
            curr = firsts[j] + m * i
            if curr > r + 1:
                f += 1
                curr = r + 1
            forbidden.add(curr)
        if f == len(margins):
            break
        i += 1

    if not forbidden:
        return list(range(l, r + 1))

    nums = []
    last = l - 1
    if x <= r:
        forbidden = forbidden | {x}
    forbidden = sorted(forbidden)

    for i in forbidden:
        nums += list(range(last + 1, i))
        last = i
    
    nums += list(range(forbidden[-1] + 1, r + 1))

    return nums

def test():
    for _ in range(100000):
        x = randint(1, 100)
        l = randint(1, 100)
        r = l + randint(0, 100 - l)
        #print(x, l, r)
        a1 = to_prime_numbers(x)
        
        sol1 = solve(x, l, r)
        
        forb = []

        for y in range(l, r + 1):
            a2 = to_prime_numbers(y)
            un = list(set(a2))
            p = 0
            i = 0
            while p < 2 and i < len(un):
                p += min(a2.count(un[i]), a1.count(un[i]))
                i += 1
            if p >= 2:
                forb.append(y)
        
        sol2 = [i for i in range(l, r + 1) if i not in forb]

        if sol1 != sol2:
            print('NO')
            print(sol1, sol2, x, l, r, sep='\n')

#test()

x = int(input())
l = int(input())
r = int(input())
sol = solve(x, l, r)
print(len(sol))
print(*sol)
