#include <bits/stdc++.h>
#define int long long
using namespace std;

int k;

bool is_square(int n) {
    int sq = sqrt(n);
    return sq * sq == n;
}

void solve12(int n) {
    for (int first = 1; first < n; first++) {
        int second = n - first;
        if (first == second) {
            continue;
        }
        if (is_square(first) && is_square(second)) {
            cout << "YES\n";
            cout << first << ' ' << second << '\n';
            return;
        }
    }
    cout << "NO\n";
}

void solve3(int n) {
    for (int first = 1; first < n; first++) {
        for (int second = first + 1; second < n; second++) {
            int third = n - first - second;
            if (first == second || second == third || first == third) {
                continue;
            }
            if (first + second >= n) {
                break;
            }

            if (is_square(first + second) && is_square(second + third) && is_square(third + first)) {
                cout << "YES\n";
                cout << first << ' ' << second << ' ' << third << '\n';
                return;
            }
        }
    }
    cout << "NO\n";
}

void solve34(int n) {
    for (int i = 2; i * i <= n; i++) {
        int sum12 = i * i;
        int third = n - sum12;
        for (int first = 1; first < n; first++) {
            int second = n - first - third;
            if (first == second || second == third || first == third) {
                continue;
            }
            if (first <= 0 || second <= 0 || third <= 0) {
                continue;
            }
            if (is_square(first + second) && is_square(second + third) && is_square(third + first)) {
                cout << "YES\n";
                cout << first << ' ' << second << ' ' << third << '\n';
                return;
            }
        }
    }
    cout << "NO\n";
}

bool check(vector<int> &values) {
    int total_sum = accumulate(values.begin(), values.end(), 0ll);
    for (int i : values) {
        int t = total_sum - i;
        if (!is_square(t)) {
            return false;
        }
    }
    return true;
}

void calc(int rem, vector<int> values, vector<bool> used) {
    if (rem == 0) {
        if (check(values) && values.size() == k) {
            cout << "YES\n";
            for (int i : values) {
                cout << i << ' ';
            }
            exit(0);
        }
    }
    for (int next = 1; next <= rem; next++) {
        if (!used[next]) {
            vector<int> new_values(values);
            new_values.push_back(next);
            int new_rem = rem - next;
            vector<bool> new_used(used);
            new_used[next] = true;
            calc(new_rem, new_values, new_used);
        }
    }
}

void solve5(int n) {
    vector<int> values({});
    vector<bool> used(400, false);
    calc(n, values, used);
    cout << "NO\n";
}

void smart() {
    int n;
    cin >> n >> k;
    if (k == 2) {
        solve12(n);
        return;
    } else if (k == 3) {
        solve34(n);
        return;
    } else if (n <= 300) {
        solve5(n);
        return;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    smart();
    return 0;
}