﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>

using namespace std;

#define int long long

const int inf = 2147483647;
const int MAX_N = 200001;

template<typename T>
ostream& operator<<(ostream& s, vector<T>& a) {
    for (T x : a) s << x << " ";
    s << endl;
    return s;
}

struct tri {
    int a, b, c;
    tri(int a, int b, int c) : a(a), b(b), c(c) {}
    bool operator<(const tri other) const {
        if (a != other.a) return a < other.a;
        if (b != other.b) return b < other.b;
        return c < other.c;
    }
};

void solve(int n, int k) {
    vector<int> pool;
    for (int i = 1; i * i < n; i++) pool.push_back(n - i * i);
    reverse(pool.begin(), pool.end());
    int m = pool.size();
    bitset<MAX_N> b;
    b[0] = true;
    vector<int> prev(MAX_N, -1);
    for (int x : pool) {
        bitset<MAX_N> bold = b;
        b |= b << x;
        bitset<MAX_N> update = b ^ bold;
        for (int j = update._Find_first(); j < MAX_N; j = update._Find_next(j)) {
            prev[j] = x;
        }
    }
    if (b[n]) {
        vector<int> answer;
        while (n > 0) {
            answer.push_back(prev[n]);
            n -= prev[n];
        }
        if (answer.size() != k) {
            cout << "NO";
        }
        else {
            cout << "YES\n";
            reverse(answer.begin(), answer.end());
            for (int x : answer) cout << x << " ";
        }
    }
    else {
        cout << "NO";
    }
}

signed main() {
    int n, k;
    cin >> n >> k;
    solve(n, k);
    /*
    for (int i = 1; i <= 100; i++) {
        cout << "\n\n---------- " << i << " 2\n";
        solve(i, 2);
    }
    */
}