﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>

#pragma GCC;unroll-loops

using namespace std;

#define int long long

const int inf = 2147483647;
const int MAX_N = 200001;

template<typename T>
ostream& operator<<(ostream& s, vector<T>& a) {
    for (T x : a) s << x << " ";
    s << endl;
    return s;
}

struct tri {
    int a, b, c;
    tri(int a, int b, int c) : a(a), b(b), c(c) {}
    bool operator<(const tri other) const {
        if (a != other.a) return a < other.a;
        if (b != other.b) return b < other.b;
        return c < other.c;
    }
};

void solve(int n, int k) {
    vector<int> pool;
    for (int i = 1; i * i < n; i++) pool.push_back(n - i * i);
    reverse(pool.begin(), pool.end());
    int m = pool.size();
    vector<vector<bitset<MAX_N>>> dp(m + 1, vector<bitset<MAX_N>>(k + 1, bitset<MAX_N>()));
    dp[0][0][0] = true;
    for (int pref = 1; pref <= m; pref++) {
        //cout << pref << endl;
        for (int ck = 0; ck <= k; ck++) {
            dp[pref][ck] = dp[pref - 1][ck];
            if (ck > 0) dp[pref][ck] |= (dp[pref - 1][ck - 1] << pool[pref - 1]);
        }
    }
    if (dp[m][k][n]) {
        cout << "YES\n";
        for (int pref = m - 1; pref >= 0; pref--) {
            if (dp[pref][k][n]) continue;
            cout << pool[pref] << " ";
            n -= pool[pref];
            k--;
        }
    }
    else {
        cout << "NO";
    }
}

signed main() {
    int n, k;
    cin >> n >> k;
    solve(n, k);
    /*
    for (int i = 1; i <= 100; i++) {
        cout << "\n\n---------- " << i << " 2\n";
        solve(i, 2);
    }
    */
}