#include <iostream>
#include <vector>
#include <cmath>

bool isSquare(int a) {
    int t = sqrt(a);
    return t * t == a;
}

std::vector<int> recurs(int n, int k, int last, int rn) {
    if(k == 1) {
        int t = sqrt(n);
        if(t * t == n && t > last && t * t <= rn) return {t};
        else return {-1};
    }
    int t = sqrt(std::min(n, rn));
    //if(t + 1 < k + last) return {-1};
    int sum = 0;
    for(int i = t;i > t - k;i--) sum += i * i;
    //if(sum < n) return {-1};
    for(int i = last + 1;i * i < std::min(n, rn);++i) {
        std::vector<int> a = recurs(n - i * i, k - 1, i, rn);
        if(a.size() > 0 && a[0] > 0) {
            a.push_back(i);
            return a;
        }
    }
    return {-1};
}

std::vector<int> bag(int n, int k, int last, int maxS) {
    if(k == 1) {
        int t = sqrt(n);
        if(t * t == n && t > last && n < maxS) return {t};
        else return {-1};
    }
    for(int i = last + 1;i * i < std::min(maxS, n);++i) {
        std::vector<int> a = recurs(n - i * i, k - 1, i, maxS);
        if(a.size() > 0 && a[0] > 0) {
            a.push_back(i);
            return a;
        }
    }
    return {-1};
}

std::vector<int> getAnsw(int n, int k) {
    int t = n * (k - 1);
    std::vector<int> a = bag(t, k, 0, n);
    if(a.size() == k) {
        std::vector<int> ans;
        for(int i : a) ans.push_back(n - i * i);
        return ans;
    }
    else return {-1};
}

bool check(int n, int k, std::vector<int> ans) {
    if(ans.size() < k) return true;
    int sum = 0;
    for(int i =0;i < k;++i) {
        sum += ans[i];
        if(!isSquare(n - ans[i])) return false;
    }
    return sum == n;
}

int main() {
   // int n, k;
   // std::cin >> n >> k;
    for(int n = 2;n <= 100;++n) {
        for(int k = 2;k <= 3;k++) {
            std::vector<int> ans = getAnsw(n, k);
            if(!check(n, k, ans)) std::cout << n << " " << k << "\n";
        }
    }
}
