#include <iostream>
#include <cmath>
#include <vector>

bool isPrime(long long num) {
	if (num == 1) return false;
	long long sqrt = std::sqrt(num) + 1;
	for (int i = 2; i < sqrt; i++) {
		if (num % i == 0) return false;
	}
	return true;
}

long long gcd(long long a, long long b) {
	while (true) {
		if (a == b) {
			return a;
		}
		if (a == 1 || b == 1) {
			return 1;
		}
		if (a > b) {
			a -= b;
			continue;
		}
		if (b > a) {
			b -= a;
			continue;
		}
	}
	return 1;
}

int main() {
	long long x, l, r;
	std::cin >> x >> l >> r;
	long long count = 0;
	long long tmp;
	std::vector<long long> res;
	res.reserve(1000);
	
	for (long long i = l; i <= r; i++) {
		if (i == x) continue;
		tmp = gcd(x, i);
		if (isPrime(tmp)) {
			count++;
			res.push_back(i);
		}
	}
	
	std::cout << count << std::endl;
	for (long long i : res) {
		std::cout << i << ' ';
	}
	std::cout << std::endl;
}